//----------------------------------------------------------------
/* ブラックジャック
/* by T.Mounai
/* Oh!X 1990/9より
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_CHECK='C'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

//----------------------------------------------------------------

int pnum,ct,kazu=5,i,round
int snd_pasa,snd_win,snd_lost,snd_pico,snd_wake,snd_tin
str nam
dim int card(51),hand(5),kane(1)
dim int syohai(1)={0,0}
dim str plr(2)={"うさぎさん","きつねさん","ねこさん"}
if not isLocalizeJapan() then {
	plr={"Rabit","Fox","Cat"}
}
dim char coinX68(127)={
	+&h00,&h00,&h0D,&hDD,&hDD,&h00,&h00,&h00,
	+&h00,&h00,&hDC,&hCC,&hCC,&hD0,&h00,&h00,
	+&h00,&h0D,&hCD,&hDD,&hDD,&hCD,&h00,&h00,
	+&h00,&h0D,&hCD,&hDC,&hDD,&hCD,&h00,&h00,
	+&h00,&hDC,&hDD,&hCC,&hCC,&hDC,&hD0,&h00,
	+&h00,&hDC,&hDC,&hDC,&hDD,&hDC,&hD0,&h00,
	+&h00,&hDC,&hDC,&hDC,&hDD,&hDC,&hD0,&h00,
	+&h00,&hDC,&hDD,&hCC,&hCD,&hDC,&hD0,&h00,
	+&h00,&hDC,&hDD,&hDC,&hDC,&hDC,&hD0,&h00,
	+&h00,&hDC,&hDD,&hDC,&hDC,&hDC,&hD0,&h00,
	+&h00,&hDC,&hDC,&hCC,&hCD,&hDC,&hD0,&h00,
	+&h00,&h0D,&hCD,&hDC,&hDD,&hCD,&h00,&h00,
	+&h00,&h0D,&hCD,&hDD,&hDD,&hCD,&h00,&h00,
	+&h00,&h00,&hDC,&hCC,&hCC,&hD0,&h00,&h00,
	+&h00,&h00,&h0D,&hDD,&hDD,&h00,&h00,&h00,
	+&h00,&h00,&h00,&h00,&h00,&h00,&h00,&h00
}
dim int coin(128*2-1):// H:L->(H,L)
ptrn16X68toiOS(16/2*16,coinX68,coin,NO,NO)
//
snd_pasa=a_setPlayData("bj1.mp3")
snd_win	=a_setPlayData("bj2.mp3")
snd_lost=a_setPlayData("bj3.mp3")
snd_pico=a_setPlayData("bj4.mp3")
snd_wake=a_setPlayData("bj5.mp3")
snd_tin	=a_setPlayData("bj6.mp3")
//
dinit()
repeat
	aite()
	for i=0 to 1:kane(i)=0:syohai(i)=0:next
	kinit():round=0
	repeat
		cls():wipe()
		sfl()
		betset()
		round=round+1
		deal()
		cdmore()
		hantei(syobu())
	until kane(0)=0 or kane(1)=0
	gover()
	
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう一度勝負しますか?"
		menues={"はい","いいえ"}
	} else {
		title$="Do you want to game again?"
		menues={"Yes","No"}
	}
	
	switch selectMenu(title$,menues)
		case 0:// はい
			wipe():cls()
			apage(GPAGE2):wipe()
			apage(GPAGE1)
			i=1
			break
		case 1:// いいえ
			i=0
			break
	endswitch
until i=0

// 音声バッファー開放
a_end(snd_pasa)
a_end(snd_win)
a_end(snd_lost)
a_end(snd_pico)
a_end(snd_wake)
a_end(snd_tin)

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()
end

/*========================================

func aite()
/* 対戦相手の決定
	apage(GPAGE3)
	fill16X68(8,112,87,127,2)
	pnum=rand() mod 3:nam=plr(pnum)
	gColor16X68(15):symbol(8,112,nam,FONT,FNTSZ)
	apage(GPAGE1)
endfunc

/*========================================

func kinit()
/* コインの表示
int i,j
	for i=0 to 1
		for j=0 to kazu-1
			kput(i,j,1)
		next
	next
endfunc

/*========================================

func oto(a;int)
/* 効果音
	a_play(a)
endfunc

/*========================================

func wtm(n;int)
/* 時間待ち
/* X68 10MHz n=500で42秒
	wait((42.0/500.0)*n)
//	int i
//	for i=0 to n*500:next
endfunc

/*========================================

func dinit()
/* 画面初期化
	randomize(val(mid$(time$,4,2))*100+val(right$(time$,2)))
	setgPalet16X68(1,&h000000ff)
	apage(GPAGE3)
	fill16X68(0,0,511,511,2)
	fill16X68(120,100,391,411,8)
	if isLocalizeJapan() then {
		gColor16X68( 0):symbol(31,31, "ＢＬＡＣＫ　ＪＡＣＫ",FONT,FNTSZ*2)
		gColor16X68(15):symbol(30,30," ＢＬＡＣＫ　ＪＡＣＫ",FONT,FNTSZ*2)
	} else {
		gColor16X68( 0):symbol(31,31, "BLACK JACK",FONT,FNTSZ*3)
		gColor16X68(15):symbol(30,30," BLACK JACK",FONT,FNTSZ*3)
	}
	gColor16X68(15):symbol( 8,304,localizedString("あなた","You "),FONT,FNTSZ)
endfunc

/*========================================

func cdput(x;int,y;int,n;int)
/* 札の画面表示1
	cardPut(x*60+170,y*180+120,n,NO)
	oto(snd_pasa)
endfunc

/*========================================

func oc_card(pl;int,n;int,of;int)
/* 札の画面表示2
	int cn
	if of=1 then cn=hand(pl*3+n) else cn=0
	cdput(n,pl,cn)
endfunc

/*========================================

func sfl()
/* シャッフル
int a,b,c,i
	for i=0 to  5:hand(i)=0  :next
	for i=0 to 51:card(i)=i+1:next
	for i=0 to 99
		a=rnd()*52:b=rnd()*52
		c=card(a):card(a)=card(b):card(b)=c
	next
endfunc

/*========================================

func deal()
/* 最初にカードを配る
int i=0,j=0
	repeat
		if i=2 then i=i+1
		hand(i)=card(j)
		i=i+1:j=j+1
	until i=5
	oc_card(0,0,0):wtm(1)
	oc_card(1,0,0):wtm(1)
	oc_card(0,1,1):wtm(1)
	oc_card(1,1,1):wtm(10)
	oc_card(1,0,1):ct=4
endfunc

/*========================================

func askpt(n;int)
/* 点数評価
int a
if n=0 then return(-1)
a=n mod 13
switch a
	case  0:a=10:break
	case 11:a=10:break
	case 12:a=10:break
	default:break
endswitch
return(a)
endfunc

/*========================================

func handpt1(pl;int)
/* ハンドの評価(a=1)
int a,i,n=0
	for i=0 to 2
		a=askpt(hand(pl*3+i))
		if a=-1 then break
		n=n+a
	next
	if n>21 then n=0
	return(n)
endfunc

/*========================================

func handpt2(pl;int)
/* ハンドの評価(a=10)
int a,i,n=0,af=0
	for i=0 to 2
		a=askpt(hand(pl*3+i))
		if a=-1 then break
		if a=1 and af=0 then a=11:af=1
		n=n+a
	next
	if n>21 then n=0
	return(n)
endfunc

/*========================================

func cdmore()
/* カードの追加
	if yesno() then hand(5)=card(ct):ct=ct+1:oc_card(1,2,1)
	if dcom()  then hand(2)=card(ct)        :oc_card(0,2,1)
endfunc

/*========================================

func yesno()
/* もう1枚引く（人間）
int a,x,y
dim float tpoint(1)
	msg(localizedString("もう1枚引く？","Do you cast another card?"))
	apage(GPAGE0)
	fill16X68(310,383,338,401,3)
	fill16X68(350,383,378,401,5)
	gLocate(39,24):print "yes"
	gLocate(44,24):print "no"

	repeat
		// タッチされるまで待つ
		repeat
		until getTouchStatus()<>TOUCH_NONE

		// タッチされたらその座標を得る
		int touchCnt=getTouchPoint(tpoint)
		x=tpoint(0)
		y=tpoint(1)
		a=-1:// 領域外
		if (y>=383 and y<=401) then {
			if (x>=310 and x<=338) then a=1:// yes
			if (x>=350 and x<=378) then a=0:// no
		}
	until a<>-1
	// yesまたはnoがタップされた
	apage(GPAGE1)
	cls():msg("")
	fill16X68(182,236,296,276,0)
	return(a)
endfunc

/*========================================

func dcom()
/* もう1枚引く（コンピューター）
int a,p1,p2,pt,ps,rr
	p1=handpt1(0):p2=handpt2(0)
	if p1>p2 then pt=p1 else pt=p2
	rr=rand() mod 5+3
	ps=21-pt
	if ps>7  then return(1)
	if ps<3  then return(0)
	if ps>rr then return(1)
	return(0)
endfunc

/*========================================

func syobu()
/* 勝負
int p1,p2,m,c
	msg(localizedString("勝  負！","Duel!!"))
	oto(snd_pico):wtm(20):msg("")
	oc_card(0,0,1)
	p1=handpt1(0):p2=handpt2(0)
	if p1<p2 then c=p2 else c=p1
	p1=handpt1(1):p2=handpt2(1)
	if p1<p2 then m=p2 else m=p1
	gLocate(45,10):print c:wtm(10)
	gLocate(45,20):print m:wtm(5)
	if c>m then return(0)
	if c<m then return(1)
	return(-1)
endfunc

/*========================================

func msg(m;str)
/* メッセージ表示
	if m="" then {
		apage(GPAGE0)
		wipe()
		apage(GPAGE1)
	} else {
		apage(GPAGE0)
		int sx=190-5*8
		fill16X68(sx,244,316+6*8,276,4)
		int wd1=(316+6*8-sx+1):// 描画領域幅
		int wd=utf8StrWidth(m):// 描画文字幅
		wd1=(wd1-wd*8)/2:// センタリングするときのオフセット
		gColor16X68(15):symbol(sx+wd1,252,m,FONT,FNTSZ)
		apage(GPAGE1)
	}
endfunc

/*========================================

func hantei(n;int)
/* 勝利判定
	switch n
		case  0:
			msg(localizedString("私の勝ち ","Computer win")):oto(snd_lost):wtm(10)
			kput(0,kane(0),1) :betclr(0):wtm(3)
			kput(0,kane(0),1) :betclr(1)
			syohai(0)=syohai(0)+1:break
		case  1:
			msg(localizedString("あなたの勝ち","You win")):oto(snd_win):wtm(10)
			kput(1,kane(1),1):betclr(0):wtm(3)
			kput(1,kane(1),1):betclr(1)
			syohai(1)=syohai(1)+1:break
		case -1:
			msg(localizedString("引き分け","Draw")):oto(snd_wake):wtm(10)
			kput(0,kane(0),1):betclr(0):wtm(3)
			kput(1,kane(1),1):betclr(1):break
	endswitch
	wtm(20):msg("")
endfunc

/*========================================

func kput(pl;int,n;int,f;int)
/* コイン表示
int x,y
	apage(GPAGE2)
	switch pl
		case 0:y=128:break
		case 1:y=320:break
	endswitch
	x=(n mod 5)*16+8
	y=y+(n/5)*16
	if f then {
		bitmapPut(x,y,x+15,y+15,coin)
		bitmapImgLoad()
		oto(snd_tin)
		kane(pl)=kane(pl)+1
	} else {
		fill16X68(x,y,x+15,y+15,0)
		kane(pl)=kane(pl)-1
	}
	apage(GPAGE1)
endfunc

/*========================================

func betset()
/* 掛け金を表示
	// 自分（あなた）
	kput(1,kane(1)-1,0)
	oto(snd_tin)
	apage(GPAGE2)
	bitmapPut(96,304,111,319,coin)
	bitmapImgLoad()
//	apage(GPAGE1)
	wtm(3)
	// 相手分
	kput(0,kane(0)-1,0)
	oto(snd_tin)
	apage(GPAGE2)
	bitmapPut(96,112,111,127,coin)
	bitmapImgLoad():// これの終了が遅れることがある
	apage(GPAGE1)
	wtm(3):// wait()中は描画が進行しない(なぜ？)
endfunc

/*========================================

func betclr(n;int)
/* 掛け金を消す
	int y
	if n=0 then y=112 else y=304
	apage(GPAGE2)
	fill16X68(96,y,111,y+15,0)
	apage(GPAGE1)
endfunc

/*========================================

func gover()
/* ゲームオーバー
int a,win,lost,ave
str winner
	cls():apage(GPAGE0):fill16X68(150,150,361,361,3)
	win=syohai(1):lost=syohai(0)
	winner=localizedString("あなた","You ")
	if kane(1)=0 then {
		a=win:win=lost:lost=a
		winner=plr(pnum)
	}
	ave=(win*100)/(round-(round-win-lost))
	if isLocalizeJapan() then {
		gLocate(22,11):print winner;"が勝ちました"
		gLocate(22,13):print" ラウンド数";round
		gLocate(21,15):print win;" 勝 ";lost;" 敗 ";round-win-lost; " 分"
		gLocate(22,17):print" 勝率は";ave;"% です"
	} else {
		gLocate(22,11):print winner;" win."
		gLocate(22,13):print" Round";round
		gLocate(21,15):print win;" win ";lost;" lose ";round-win-lost;" draw"
		gLocate(22,17):print" Winning rate is";ave;"%."
	}
endfunc

/*========================================
